unit Unit1;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type

  TDLLFunction = function(someParam: String): String;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button4: TButton;
    Label3: TLabel;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    Button5: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Button6: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Button7: TButton;
    Edit3: TEdit;
    Button8: TButton;
    Label11: TLabel;
    Button9: TButton;
    Edit4: TEdit;
    Button10: TButton;
    Edit5: TEdit;
    Label12: TLabel;
    Button11: TButton;
    CheckBox1: TCheckBox;
    Label7: TLabel;
    GroupBox9: TGroupBox;
    Button13: TButton;
    Label13: TLabel;
    Edit2: TEdit;
    GroupBox10: TGroupBox;
    Button12: TButton;
    Button14: TButton;
    Label2: TLabel;
    Edit6: TEdit;
    Label14: TLabel;
    procedure Button1Enter(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SetaVisibilidadeBox(arg: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure MostraMensagem(arg: String);
    function LocalCheckIcBox(timeOut: Integer) : String;
    procedure Button12Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button14Click(Sender: TObject);
    procedure GroupBox10Exit(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }

     Conectado : Boolean;
     Modo_Programacao: Boolean;
  end;
const
   NOMEDLL = 'IcBox.dll';
var
  Form1: TForm1;
  Conectado : Boolean;


implementation

 uses Unit3;

 var
    _MinhaThread: ICBOXThread;

{$R *.dfm}
//Faz a associao dos mtodos da DLL
function testCom(retBuffer: PAnsiChar ; arg: String): Integer ; stdcall; external NOMEDLL;
function openSetupDialog(retBuffer: pChar ): Integer ; stdcall; external NOMEDLL;
function isConnected(): Boolean ; stdcall; external NOMEDLL;
function openCom(retBuffer: pChar ; arg: String): Integer ; stdcall; external NOMEDLL;
function closeCom(): Boolean ; stdcall; external NOMEDLL;
function getOnHook(): Boolean ; stdcall; external NOMEDLL;
procedure setIsConectted(arg : Boolean) ; stdcall; external NOMEDLL;
function getVersionInfo(retBuffer: pChar ): Integer ; stdcall; external NOMEDLL;
procedure initialize() ; stdcall; external NOMEDLL;
procedure finalize() ; stdcall; external NOMEDLL;
function getEvent(retBuffer: pChar ; timeOut: Integer): Integer ; stdcall; external NOMEDLL;
function getRXLevel(retBuffer: pChar ): Integer ; stdcall; external NOMEDLL;
function getRXMode(retBuffer: pChar ): Integer ; stdcall; external NOMEDLL;
function getId(retBuffer: pChar ): Integer ; stdcall; external NOMEDLL;
function setRXLevel(arg : Integer): Boolean ; stdcall; external NOMEDLL;
function setRXMode(arg: Integer): Boolean ; stdcall; external NOMEDLL;
function setId(arg: AnsiString): Boolean ; stdcall; external NOMEDLL;
function checkConnectionStatus(): Boolean ; stdcall; external NOMEDLL;
function dialNumber(arg: String): Boolean ; stdcall; external NOMEDLL;

procedure TForm1.MostraMensagem(arg: String);
begin
  ShowMessage(arg);
end;

function TForm1.LocalCheckIcBox( timeOut: Integer) : String;

 var
 valor :  String;
 retorno : pChar;
 size :Integer;

 begin
   valor := '' ;
   retorno := StrAlloc(47);
   size := getEvent(retorno, timeout);
   if(size >0)
    then
     begin
      valor  := Pchar(retorno);
     end;
  Result :=  valor;
end;

procedure TForm1.Button1Enter(Sender: TObject);
begin
  ShowMessage('inicio');

end;

procedure TForm1.Button1Click(Sender: TObject);
 var
  teste: String;
  retorno : PAnsiChar;
  size :Integer;

begin
    retorno := 0;
    retorno := StrAlloc(10);
    try
      size := openSetupDialog(retorno);
      if (size > 0)
       then 
        begin
          teste :=  PChar(retorno);
        end;

       if(teste <> '')
         then
            begin
             Edit2.Text := teste;
             end;
     except
        on E : Exception  do
          ShowMessage(E.Message);
     else
     begin

     ShowMessage('Erro');
      Application.Terminate;
     end;
     end;
     StrDispose( retorno );

end;

procedure TForm1.Button2Click(Sender: TObject);
begin

  if (isConnected())
     then
       Form1.Label4.Caption := 'Conectado'
     else
       Form1.Label4.Caption := 'Desconectado';


end;

procedure TForm1.Button3Click(Sender: TObject);

var
  resultado: String;
  porta: String;
  retorno : pChar;
  size :Integer;
begin
 try
 retorno := StrAlloc(10);
 if (isConnected())
  then
    begin
    if(closeCom())
     then
      begin
       Button3.Caption := 'Conectar';
       GroupBox2.Visible := false;
       SetaVisibilidadeBox(false);
       Conectado := false;
      end;
    end
  else
    begin
      porta := Trim(Edit2.Text);
      if (porta = '')
      then
        begin
         ShowMessage('Selecione ou digite uma porta COM vlida');
         Exit;
        end;
        size := openCom(retorno, porta);
        if(size >0)
         then
           begin
            resultado := PChar(retorno);
           end; 
      if(resultado = '')
        then
          begin
           Button3.Caption := 'Desconectar';
           SetaVisibilidadeBox(true);
           Conectado :=  true;
         end
        else
         begin
          ShowMessage(resultado);
         end;
    end;
 except
   on E : Exception  do
         ShowMessage(E.Message);
     else
     begin
     ShowMessage('Erro ao realizar a operao');
      Application.Terminate;
      StrDispose( retorno );
     end;
  end;
       StrDispose( retorno );
end;

 procedure  TForm1.SetaVisibilidadeBox(arg: Boolean) ;
 begin
 Form1.GroupBox2.Visible := arg;
 Form1.GroupBox3.Visible := arg;
 Form1.GroupBox4.Visible := arg;
 Form1.GroupBox5.Visible := arg;
 Form1.GroupBox6.Visible := arg;
 Form1.GroupBox7.Visible := arg;
 Form1.GroupBox8.Visible := arg;
 Form1.GroupBox9.Visible := arg;
 Form1.GroupBox10.Visible := arg;
 end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 SetaVisibilidadeBox(false);
    _MinhaThread := ICBOXThread.Create (false, Self);

end;

procedure TForm1.Button4Click(Sender: TObject);
var
 resultado: String;
 retorno : pChar;
size :Integer;

begin

 retorno := StrAlloc(10);
 if(isConnected())
   then
     begin
       size := getVersionInfo(retorno);
       if(size >0)
        then
          begin
            resultado := PChar(retorno);
         end;   
        Form1.Label3.Caption := resultado;
     end
   else
    StrDispose( retorno );
    Exit;


end;
//===========================================================================//
procedure TForm1.Button5Click(Sender: TObject);
begin
  if(getOnHook())
     then
       Form1.Label5.Caption := 'No gancho'
      else
       Form1.Label5.Caption := 'Fora do gancho';
end;
//===========================================================================//
procedure TForm1.Button7Click(Sender: TObject);
var
 valor : String;
 retorno : pChar;
 size :Integer;
 begin
   retorno := StrAlloc(10);
   size := getRXLevel(retorno);
   if(size >0)
    then
     begin
      valor  := Pchar(retorno);
     end;

    if(valor <> '0')
      then
       Form1.Label10.Caption := valor;
     StrDispose( retorno );
 end;
//===========================================================================//
procedure TForm1.Button9Click(Sender: TObject);
var
  valor: String;
  retorno : pChar;
  size :Integer;
begin
  retorno := StrAlloc(10);
  size := getRXMode(retorno);
  if(size >0)
    then
     begin
      valor  := Pchar(retorno);
     end;

  if(valor <> '')
    then
      Form1.Label11.Caption :=  valor;
       StrDispose( retorno );
end;
//===========================================================================//
procedure TForm1.Button8Click(Sender: TObject);
var
 valorStr : String;
 valor: Integer;
begin
   valorStr := Trim(Form1.Edit3.Text);
   valor := StrToInt(valorStr);
   if((valor > 0)and(valor < 9))
     then
       begin
        if (setRXLevel(valor))
          then
            begin
             ShowMessage('Level setado com sucesso');
             Form1.Label10.Caption :=  IntToStr(valor);
            end
           else
            ShowMessage('Erro ao setar level')
       end
      else
        begin
          ShowMessage('Valor invlido');
        end;

end;

//===========================================================================//
procedure TForm1.Button10Click(Sender: TObject);
var
 valorStr : String;
 valor: Integer;
begin
   valorStr := Trim(Form1.Edit4.Text);
   valor := StrToInt(valorStr);
   if((valor > 0)and(valor < 9))
     then
       begin
        if (setRXMode(valor))
          then
           begin
            ShowMessage('Modo setado com sucesso');
            Form1.Label11.Caption :=  IntToStr(valor);
           end
           else
            ShowMessage('Erro ao setar modo')
       end
      else
        begin
          ShowMessage('Mdo invlido');
        end;

end;

//============================================================================//
procedure TForm1.Button11Click(Sender: TObject);
var
valorEdit: String;
caracter : String;
caracterInt : Integer;
cont: Integer;
j: integer;
begin
  if(not(isConnected()))
      then
         begin
          ShowMessage('No conectado ao ic-box');
          Exit;
         end;

  valorEdit := Trim(Form1.Edit5.Text);
  cont := Length(valorEdit);
  if  (cont > 0)
    then
      begin
        for  j := 0 to cont-1 do
         begin
            caracter := Copy(valorEdit, j+1, 1);
          try
            caracterInt := StrToInt(caracter);
            if((caracterInt < 0)or(caracterInt > 9))
             then
              begin
               ShowMessage('O campo possui caractere(s) invlido(s)');
               Exit;
              end;
          except
           on Exception : EConvertError do
                  if((caracter <> 'P')and(caracter <> 'p'))
                  then
                   begin
                    ShowMessage('O campo possui caractere(s) invlido(s)');
                    Exit;
                   end;

           end;
        end;
     end;   

   if  (cont > 19)
      then
        begin
          ShowMessage('O limite mximo so de 19 digitos para discagem');
          Exit;
        end;



   if(dialNumber(valorEdit))
     then
     ShowMessage('Nmero discado com sucesso');
   

end;
//============================================================================//
procedure TForm1.Button12Click(Sender: TObject);
var
  valor: String;
  retorno : pChar;
  size :Integer;
begin
  retorno := StrAlloc(10);
  size := getId(retorno);
  if(size <> 0)
  then
   begin
    valor := PChar(retorno);
   end;
  //valor := getId();
  if(valor <> '')
    then
      Form1.Label2.Caption :=  valor;

       StrDispose( retorno );
end;
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin

 Modo_Programacao := CheckBox1.Checked
end;

//=============================================================================
procedure TForm1.Button6Click(Sender: TObject);
var
  comando: String;
  resultado: String;
  retorno : pChar;
  size :Integer;
begin
    retorno := StrAlloc(10);
   comando := Trim(Edit1.Text)+#13#10;
   if (comando <> '')
     then
       size := testCom(retorno, comando);
       if(size <> 0)
       then begin
        resultado := PChar(retorno);
       end;
      Label9.Caption :=  resultado;
       StrDispose( retorno );    
end;

procedure TForm1.Button13Click(Sender: TObject);
begin


   if (checkConnectionStatus())
    then
      begin
       Label13.Caption := 'Comunicao ok';
      end
    else
       begin
       Label13.Caption := 'Problemas na Comunicacao';
       end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   finalize();
end;

procedure TForm1.Button14Click(Sender: TObject);
var
 valorStr : String;
begin
   valorStr := Trim(Form1.Edit6.Text);

   if(Length(valorStr) = 3){or (valorStr. = '000'))}
     then
       begin
        if (setId(valorStr))
          then
           begin
            ShowMessage('Id gravado com sucesso');
            Form1.Label11.Caption :=  valorStr;
           end
           else
            ShowMessage('Erro ao setar Id, o valor deve ser \r\n entre 001 e 999')
       end
      else
        begin
          ShowMessage('Erro ao setar Id, o valor deve ser \r\n entre 001 e 999');
        end;

end;



procedure TForm1.GroupBox10Exit(Sender: TObject);
begin
   //saindo...
end;

end.
